SystemOrganization addCategory: #'TPMetaprogramacion2.2'!
SystemOrganization addCategory: #'TPMetaprogramacion2.2-Testing'!
SystemOrganization addCategory: #'TPMetaprogramacion2.2-Testing-Tests'!

TestCase subclass: #ProblematicatestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPMetaprogramacion2.2-Testing-Tests'!

!ProblematicatestTest commentStamp: '<historical>' prior: 0!
A ProblematicatestTest is a test class for testing the behavior of Problematicatest!

!ProblematicatestTest methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/3/2013 23:28'!
testNoPresentaProblematica
|nuevaclase refactor|

nuevaclase := (Object subclass: #Arqueroo  instanceVariableNames:'velocidad potenciatiro cabezazo 'classVariableNames:'' poolDictionaries:''  category: 'Deporte').

nuevaclase  compile:'habilidadgoleadora
                                      ^velocidad+cabezazo+potenciatiro'.

nuevaclase  compile:'habilidadmediocampo 
                                      ^velocidad+potenciatiro'.


refactor:= Metaprograma new.

self assert:(refactor presentaproblematica: nuevaclase)not
! !

!ProblematicatestTest methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/3/2013 23:33'!
testPresentaProblematica
|nuevaclase refactor|

nuevaclase := (Object subclass: #Arquero  instanceVariableNames:'velocidad potenciatiro cabezazo altura reflejos'classVariableNames:'' poolDictionaries:''  category: 'Deporte').

nuevaclase  compile:'habilidadgoleadora
                                      ^velocidad+cabezazo+potenciatiro'.

nuevaclase  compile:'habilidadmediocampo 
                                      ^velocidad+potenciatiro'.

nuevaclase  compile: 'habilidadatajando
                                       ^reflejos+altura'.

refactor:= Metaprograma new.

self assert:(refactor presentaproblematica: nuevaclase).! !

!ProblematicatestTest methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/4/2013 00:17'!
testRefactor
|nuevaclase refactor cantatributosoriginales cantatributosactuales|

nuevaclase := (Object subclass: #Arquero  instanceVariableNames:'velocidad potenciatiro cabezazo altura reflejos'classVariableNames:'' poolDictionaries:''  category: 'Deporte').

nuevaclase  compile:'habilidadgoleadora
                                      ^velocidad+cabezazo+potenciatiro'.

nuevaclase  compile:'habilidadmediocampo 
                                      ^velocidad+potenciatiro'.

nuevaclase  compile: 'habilidadatajando
                                       ^reflejos+altura'.

refactor:= Metaprograma new.

cantatributosoriginales := nuevaclase instVarNames size.

refactor refactor:nuevaclase nuevaclase: #Mediocampista.

cantatributosactuales := nuevaclase instVarNames size.

self assert:(cantatributosoriginales > cantatributosactuales )


! !

Object subclass: #Metaprograma
	instanceVariableNames: 'atributospasar metodospasar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPMetaprogramacion2.2'!

!Metaprograma methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/3/2013 17:16'!
crearclase: unaClase nuevaclase:nuevaclass
|nuevaclase metodosporatributo metodosinrepetidos|
nuevaclase := (Object  subclass:nuevaclass instanceVariableNames:''  classVariableNames:''  poolDictionaries:''  category:unaClase category).

atributospasar do:[:a| nuevaclase addInstVarNamed: a].

unaClase addInstVarNamed: nuevaclass.

unaClase methodDictionary do:[:m| nuevaclase compile: m getSource ].

metodosporatributo:=unaClase instVarNames collect:[:a| unaClase whichSelectorsAccess: a].

metodosinrepetidos:=metodosporatributo inject: Set new into: [:acum :a| acum union: a].

metodosinrepetidos do:[:a| nuevaclase removeSelector: a]! !

!Metaprograma methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/3/2013 23:27'!
presentaproblematica:unaClase
|atributos metodosporatributo metodosapasar metodosporatributosinrepetidos|

metodospasar := Set new.
atributospasar := Set new.

atributos:=unaClase instVarNames.

metodosporatributo:=atributos collect:[:a| unaClase whichSelectorsAccess: a].

metodosapasar :=metodosporatributo inject: (metodosporatributo first:1) into:[:acum :metodos| (metodos anySatisfy:[:metodo| acum includes:metodo])
	ifTrue:[ acum union: metodos]
	 ifFalse: [acum] ].

metodospasar:= metodosapasar inject: Set new into:[:acum :m| acum union: m].

metodosporatributosinrepetidos:=metodosporatributo inject: Set new into:[:acum :m| acum union: m].

atributospasar:= atributos select:[:a| metodospasar anySatisfy:[:m| (unaClase whichSelectorsAccess: a) includes:m]].

^ (metodosporatributosinrepetidos size = metodospasar size) not










 



! !

!Metaprograma methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/3/2013 17:16'!
refactor:unaClase nuevaclase:nuevaclass
(self presentaproblematica: unaClase)
ifTrue:[self removeratributos: unaClase; crearclase: unaClase nuevaclase:nuevaclass;removermetodos: unaClase ] ! !

!Metaprograma methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/2/2013 12:07'!
removeratributos: unaClase
atributospasar do:[:a|unaClase removeInstVarNamed:a]! !

!Metaprograma methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/2/2013 12:06'!
removermetodos: unaClase
metodospasar do:[:m| unaClase  removeSelector:m]! !
